import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;

public class CheckBoxEditor extends DefaultCellEditor implements ItemListener{
    private JCheckBox checkBox;
    int c;

    public CheckBoxEditor(JCheckBox checkBox) {
	super(checkBox);
	checkBox = new JCheckBox();
    }
	
    public Component getTableCellEditorComponent(JTable table, Object value,
						 boolean isSelected, int row, int column) {	    
	if (value == null) return null;
	c = column;
	//System.out.println(value.getClass());
	checkBox = (JCheckBox)value;
	checkBox.addItemListener(this);
	((Component)value).setBackground(Color.WHITE);
	return (Component)value;
    }
	
    public Object getCellEditorValue() {
	checkBox.removeItemListener(this);
	return null;
    }
	
    public void itemStateChanged(ItemEvent e){
	FormationEditor.instance.aF.player[c].behindBall = !FormationEditor.instance.aF.player[c].behindBall;
	super.fireEditingStopped();
    }
}
