import java.awt.event.*;
import javax.swing.*;
import java.awt.Dimension;

public class MenuItemActionListener implements ActionListener{
    FormationEditor fe = FormationEditor.instance;
    String lfpb = "";

    public void actionPerformed(ActionEvent e){
	if (fe == null) fe = FormationEditor.instance;

	if ((new JComboBox()).getClass() == e.getSource().getClass()){
	    for (int i = 0; i < 11; i++){	    
		if (e.getSource() == fe.sB[i])
		    fe.aF.player[i].type = fe.sB[i].getSelectedIndex();
	    }
	    return;
	}
	if ((new JButton()).getClass() == e.getSource().getClass()){
	    if(e.getSource() == fe.sHP){
		if      (fe.mode.equals("init")) { 
		    fe.mode = "home"; fe.sHP.setText("HomePosition"); 
		}else if (fe.mode.equals("ball")) { 
		    fe.mode = "init"; fe.sHP.setText("InitPosition"); 
		}else if (fe.mode.equals("home")) { 
		    fe.mode = "ball"; fe.sHP.setText("PredictedPosition"); 
		}		
		fe.playerButtons[fe.activePlayer].doClick();
		fe.playerButtons[fe.activePlayer].setSelected(true);
		fe.field.repaint();
		return;
	    }else if(e.getSource() == fe.cycleLeft){
		try{
		    fe.cyclePrev();
		}catch(Exception e2){
		    System.out.println("Can't cycle WorldModel to the left.");
		}
	    }else if(e.getSource() == fe.cycleRight){
		try{
		    fe.cycleNext();
		}catch(Exception e2){
		    System.out.println("Can't cycle WorldModel to the right.");
		}
	    }else if(e.getSource() == fe.play){
		if (fe.play.getText().equals("Play")){
		    fe.play();
		}else{
		    fe.stop();
		}
	    }else if(e.getSource() == fe.jb_rotateView){
		fe.rotate();
		//System.out.println("Rotate view...");
		fe.field.repaint();
		fe.bottom.repaint();
	    }
	    return;
	}
	if ((new JToggleButton()).getClass() == e.getSource().getClass()){
	    for (int i = 0; i < 11; i++){
		if(e.getSource() == fe.playerButtons[i]){
		    fe.playerButtons[fe.activePlayer].setSelected(false);		    
		    fe.maxXButtons[fe.activePlayer].setSelected(false);		    
		    fe.minXButtons[fe.activePlayer].setSelected(false);		    
		    fe.activePlayer = i;
		    fe.toChange = "pos";
		    fe.playerButtons[i].setSelected(true);
		    if (fe.mode.equals("init") && 
			FormationEditor.isInvalidVector2DForInit(fe.aF.player[i].initPosition)){
			fe.playerButtons[i].setIcon(new ImageIcon("status-error.png"));
		    }else if (fe.mode.equals("home") && 
			      FormationEditor.isInvalidVector2D(fe.aF.player[i].homePosition)){
			fe.playerButtons[i].setIcon(new ImageIcon("status-error.png"));
		    }else{
			fe.playerButtons[i].setIcon(new ImageIcon("status-deselected.png"));
		    }
		    lfpb += ""+(i+1);
		    if (lfpb.length() > 4)
			lfpb = lfpb.substring(lfpb.length()-4);

		    if (lfpb.equals("1337")) { fe.al = true; }
		    else { fe.al = false; }
		    fe.field.repaint();
		    return;
		}
		if(e.getSource() == fe.minXButtons[i]){
		    fe.playerButtons[fe.activePlayer].setSelected(false);		    
		    fe.maxXButtons[fe.activePlayer].setSelected(false);		    
		    fe.minXButtons[fe.activePlayer].setSelected(false);
		    fe.activePlayer = i;
		    fe.toChange = "min";
		    fe.minXButtons[i].setSelected(true);				
		    fe.field.repaint();
		    return;
		}
		if(e.getSource() == fe.maxXButtons[i]){
		    fe.playerButtons[fe.activePlayer].setSelected(false);		    
		    fe.maxXButtons[fe.activePlayer].setSelected(false);		    
		    fe.minXButtons[fe.activePlayer].setSelected(false);
		    fe.activePlayer = i;
		    fe.toChange = "max";
		    fe.maxXButtons[i].setSelected(true);				
		    fe.field.repaint();
		    return;
		}
	    }
	    return;
	}
	if ((new JMenuItem()).getClass() == e.getSource().getClass()){
	    if(e.getSource() == fe.mstats){
		if (fe.stats == null){
		    fe.stats = new Statistics();
		}else{
		    fe.stats.dispose();
		    fe.stats = null;
		}
	    }
	    if(e.getSource() == fe.copy)
		fe.copyFormation();
	    if(e.getSource() == fe.delete)
		fe.deleteFormation();
	    if(e.getSource() == fe.s_export)
		fe.saveAs();
	    if(e.getSource() == fe.l_import)
		fe.loadFrom();
	    if(e.getSource() == fe.j_import)
		fe.loadFromUvA();
	    if(e.getSource() == fe.j_export)
		fe.saveAsUvA();
	    if(e.getSource() == fe.l_wm)
		fe.loadWorldModel();
	    if(e.getSource() == fe.ul_wm)
		fe.unloadWorldModel();
	    if(e.getSource() == fe.create){
		fe.createNewFormation();
		fe.field.repaint();
	    }
	    if(e.getSource() == fe.print)
		fe.print();
	    if(e.getSource() == fe.load)
		fe.load();
	    if(e.getSource() == fe.save)
		fe.save();
	    if(e.getSource() == fe.quit)
		System.exit(0);
	    if(e.getSource() == fe.gridp){
		if (fe.gridSize >= 0.05) 
		    fe.gridm.setEnabled(true);
		fe.gridSize += 0.05;
		fe.field.repaint();
	    }
	    if(e.getSource() == fe.gridm){
		if (fe.gridSize <= 0.05) return;
		fe.gridSize -= 0.05;
		if (fe.gridSize <= 0.05) 
		    fe.gridm.setEnabled(false);
		fe.field.repaint();
	    }
	    if(e.getSource() == fe.zoomin){
		    if (fe.ZOOM == 1) 
			fe.zoomout.setEnabled(true);
		    fe.ZOOM++;	
		    Dimension fS = new Dimension((int)(fe.ZOOM*
						       (fe.PITCH_LENGTH)+ 
						       fe.PITCH_MARGIN*2),
						 (int)(fe.ZOOM*
						       (fe.PITCH_WIDTH )+ 
						       fe.PITCH_MARGIN*2));
		    fe.field.setMaximumSize(fS);
		    fe.field.setPreferredSize(fS);
		    fe.field.setSize((int)fS.getWidth(), (int)fS.getHeight());
		    fe.field.repaint();
	    }
	    if(e.getSource() == fe.zoomout){
		    fe.ZOOM--;		    
		    if (fe.ZOOM == 1) fe.zoomout.setEnabled(false);
		    Dimension fieldSize = new Dimension((int)(fe.ZOOM*(fe.PITCH_LENGTH) + 
							      fe.PITCH_MARGIN*2),
							(int)(fe.ZOOM*(fe.PITCH_WIDTH ) + 
							      fe.PITCH_MARGIN*2));
		    fe.field.setMaximumSize(fieldSize);
		    fe.field.setPreferredSize(fieldSize);
		    fe.field.setSize((int)fieldSize.getWidth(), (int)fieldSize.getHeight());
		    fe.field.repaint();
	    }
	    return;
	}
	if ((new JRadioButtonMenuItem()).getClass() == e.getSource().getClass()){
	    if(e.getSource() == fe.r_speed ||
	       e.getSource() == fe.r_quality)
		fe.field.repaint();		
	    return;
	}
	if ((new JCheckBoxMenuItem()).getClass() == e.getSource().getClass()){
	    if(e.getSource() == fe.pong){
		if (fe.pong.getState()){
		    fe.field.addMouseMotionListener(new FieldMouseInputAdapter());
		    fe.mode = "ball";
		    fe.p = new Pong();	
		    fe.field.requestFocus();
		    fe.p.start();
		}else{
		    MouseMotionListener mml[] = fe.field.getMouseMotionListeners();
		    if (fe.p != null && fe.p.isAlive()) fe.p.destroy();
		    fe.field.removeMouseMotionListener(mml[0]);
		    fe.field.repaint();
		}
	    }
	    if(e.getSource() == fe.antialias ||
	       e.getSource() == fe.antialiasText ||
	       e.getSource() == fe.showLimits ||
	       e.getSource() == fe.tgrid)
		fe.field.repaint();		
	    return;
	}
	if ((new JTextField()).getClass() == e.getSource().getClass()){
	    if (e.getSource() == fe.tf_id){
		try{
		    fe.aF.id = Integer.parseInt(((JTextField)e.getSource()).getText());
		}catch(Exception e2){
		}
		fe.tf_id.setText(""+ fe.aF.id);
		fe.updateFormationMenu();
	    }
	    if (e.getSource() == fe.tf_name){
		try{
		    fe.aF.name = ((JTextField)e.getSource()).getText();
		}catch(Exception e2){
		}
		fe.tf_id.setText(fe.aF.name);
		fe.updateFormationMenu();
	    }
	    if (e.getSource() == fe.cycleEdit){
		try{
		    int cycle = Integer.parseInt(fe.cycleEdit.getText());
		    int sc_cycle = Integer.parseInt(fe.cycleEdit2.getText());
		    fe.cycle(cycle, sc_cycle);
		}catch(Exception e2){
		}
		return;
	    }
	    if (e.getSource() == fe.cycleEdit2){
		try{
		    int cycle = Integer.parseInt(fe.cycleEdit2.getText());
		    int sc_cycle = Integer.parseInt(fe.cycleEdit2.getText());
		    fe.cycle(cycle, sc_cycle);
		}catch(Exception e2){
		}
		return;
	    }
	}
    }
}
