/*****************************************************************************
 * Sensors.cc
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   class Sensors
 *
 * requires:
 *
 *
 * Created on: 25.03.2001 by wenns
 * Maintainer: cyco
 * Group:
 * Co-authors: wenns
 *
 *
 * $Id: Sensors.cc,v 1.1.1.1 2004/01/30 15:13:41 harlekin Exp $
 *****************************************************************************/

#include "Sensors.hh"

Sensors::Sensors(Communicator *aComm, const char *teamname){
  comm = aComm;
  parser.setTeamname(teamname);
}

Sensors::~Sensors() {}

void Sensors::sense()
{
  //block here
  comm->getNextMessage(message);

  //DEBUG1(message);

  parser.parse(message);
}

// $Source: /home/robocup/virtualwerder/CVSRepository/VirtualWerder2004/Sensors.cc,v $
