/******************************************************************************
 * Team.cc
 * Copyright (c) 2001 Virtual Werder
 *
 * implements:
 *   class Team
 *
 * requires:
 *
 * Created on: 22.08.2001 by wenns
 * Maintainer: wenns
 * Group:
 * Co-authors:
 *
 * Changelog:
 *
 ******************************************************************************/

#include <algorithm>

#include "Team.hh"

Team::Team() : players(){
  for(int i = 0; i < TEAM_SIZE; i++)
    players.push_back(Player());
  
  strcpy(name, "");
}

Team::~Team(){}

const Player *Team::getGoalie() const {
  static vector<Player>::const_iterator i;
  i = find_if(players.begin(), players.end(), isGoalie());

  if(i == players.end()) //goalie not found
    return NULL;
  else
    return (const Player*)&(*i);        //isnt nonsense: * isnt dereferencing
}




