public class Test{
    public static void printVelocity(){
	System.out.println("<velocity>");
	System.out.println("<x>"+ random(-50,50) +"</x>");
	System.out.println("<y>"+ random(-50,50) +"</y>");
	System.out.println("<confidence>"+ random(0,1) +"</confidence>");
	System.out.println("</velocity>");	    
    }
    public static void printPosition(){
	System.out.println("<position>");
	System.out.println("<x>"+ random(-50,50) +"</x>");
	System.out.println("<y>"+ random(-50,50) +"</y>");
	System.out.println("<confidence>"+ random(0,1) +"</confidence>");
	System.out.println("</position>");	    
    }
    public static void printTeam(String name, String side){
	System.out.println("<team>");
	System.out.println("<name>"+ name +"</name>");
	System.out.println("<side>"+ side +"</side>");
	for(int i = 1; i <= 11; i++)
	    printPlayer(i);
	System.out.println("</team>");
    }
    public static void printPlayer(int unum){
	System.out.println("<player>");
	System.out.println("<unum>"+ unum +"</unum>");
	printPosition();
	printVelocity();
	printDirections();
	System.out.println("</player>");
    }
    public static void printDirections(){
	System.out.println("<direction>");
	System.out.println("<body>"+ random(-180, 180) +"</body>");
	System.out.println("<head>"+ random(-90, 90) +"</head>");
	System.out.println("</direction>");
    }
    public static double random(double v, double b){
	double r = Math.rint((Math.round((Math.random()*(b-v)+v)*(double)100))/(double)100);
	if (r == -0.0) return 0.0;
	else return r;
    }
    public static void main(String[] args){
	System.out.println("<game>");
	System.out.println("<worldmodels>");
	System.out.println("<activeplayer>1</activeplayer>");
	for (int i = 1; i <= 6000; i++){
	    System.out.println("<worldmodel>");
	    System.out.println("<cycle>"+ i +"</cycle>");
	    System.out.println("<ball>");
	    printVelocity();
	    printPosition();
	    System.out.println("</ball>");
	    printTeam("VW2003", "left");
	    printTeam("UvA", "right");
	    System.out.println("</worldmodel>");
	}
	System.out.println("</worldmodels>");
	System.out.println("</game>");
    }
}
