#ifndef __WING_DEFENDER_BEHAVIOUR
#define __WING_DEFENDER_BEHAVIOUR

#include "Agent.hh"

class WingDefenderBehaviour : public Behaviour
{
public:

  /** Creates and initializes the WingDefenderBehaviour
      @param leftWing determines whether this is the Behaviour for the left or right Back
  */
  WingDefenderBehaviour(bool leftWing);

  /** Destroys the Behaviour*/
  virtual ~WingDefenderBehaviour();
  void playOnWithBall();
  void playOnWithoutBall();
  void coverEnemy();
private:

  /** Is this the left or right Back*/
  bool left;

};


#endif
